#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
 * This program is an improvement on the getinfo program from last lecture
 *
 * In this version, we check to see if the user entered too many characters
 * for a name.  If so, we truncate whatever they entered before copying
 *
 * In order to test this program, getinfo.h has been changed to have a
 * fairly small size for NAMESIZ.  It is currently set to 10
 *
 * Type in a short and a long name and see what happens
 *
 */

/* we use our own include file here, which defines NAMESIZ */
#include "getinfo.h"

main()
{
    char buf[BUFSIZ]; /* input area for user */
    char fname[NAMESIZ], lname[NAMESIZ]; /* storage area for first and last name */
    int age; /* variable for age */

    do
    { /* keep looping until a valid name is entered */
	    printf("Enter first name: "); /* ask for their first name */
	    gets(buf); /* read response */
	    if (strlen(buf) > 0 && strlen(buf) < NAMESIZ)
        { /* line short enough - copy string */
            strcpy(fname, buf);
        }
     /* keep doing this until the user enters a valid string */
    } while (strlen(buf) == 0 || strlen(buf) >= NAMESIZ);

    do
    {
	    printf("Enter last name: "); /* ask for their last name */
	    gets(buf); /* read response from user */
        /* we could do this the same way as with fname, this is another way */
        if (buf[0] == '\0') continue;   /* nothing entered - reject */
        if (strlen(buf) < NAMESIZ)
        {
            strcpy(lname, buf);
        }
    } while (strlen(buf) == 0 || strlen(buf) >= NAMESIZ);

    printf("Enter your age: "); /* ask for age */
    gets(buf); /* get response from user */
    age = atoi(buf); /* convert to a number */

    /*
     * We have all the information now, display it for the user to see
     */
    printf("Name: %s %s, age %d\n", fname, lname, age);

    printf("Press ENTER to terminate program: "); /* display another message */
	getchar(); 						/* wait for the user to press ENTER */
}
