#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/*
 * This program will fill an array with random numbers
 * and then display the results.
 *
 * The user may then enter a number, and the program will
 * how many times that number appears in the table.
 *
 */

/* define the size of the table */
#define MAXENT 100

/* prototype for the find_first routine */
int count_ents(int array[], int maxsize, int key);

main()
{
    int tbl[MAXENT];    /* the table to be filled */
    int i, key, fnd;    /* loop variable, number to find, location where found */
    char buf[BUFSIZ];

    srand(time(NULL));  /* make actual random numbers */

    for (i=0; i < MAXENT; i++)
    { /* fill the table up with random numbers */
        tbl[i] = rand() % 100;  /* with numbers from 0 to 99 */
    }

    /*
     * The table is now filled
     * Loop through the table and display each entry
     */
    for (i=0; i < MAXENT; i++)
    { /* loop through the array */
        printf("Entry %2d is %2d\n", i, tbl[i]);
        if (i%20 == 19)
        { /* screen full - pause for user */
            printf("Press ENTER to continue: ");
            getchar(); /* wait for user to press ENTER */
        }
    }

    /*
     * now loop asking the user for a number, and find the first entry
     * containing that number
     */
    while (1)
    { /* loop until done */
        printf("Enter a number, or ENTER to quit: ");
        gets(buf);
        if (buf[0] == 0) break;
        key = atoi(buf);    /* the number we are looking for */
        fnd = count_ents(tbl, MAXENT, key);
        printf("Number %d found %d times in table\n", key, fnd);
    }

    printf("Press ENTER to terminate program: "); /* display another message */
	getchar(); 						/* wait for the user to press ENTER */
}

/* the count_ents routine */
int count_ents(int array[], int maxsize, int key)
{
    int i, ret=0;  /* loop variable, and return location */

    /* loop through table and count the number of matches */
    for (i=0; i < maxsize; i++) if (array[i] == key) ret++;
    return ret; /* ret contains how many matches we found */
}
