#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/*
 * This program will fill an array with random numbers
 * and then display the results.
 *
 * The user may then enter a number, and the program will
 * find how many times the number appears in the table,
 * and at what locations it was found.
 *
 */

/* define the size of the table */
#define MAXENT 100

/* prototype for the list_matches routine */
int list_matches(int array[], int maxsize, int key, int list[]);

main()
{
    int tbl[MAXENT];    /* the table to be filled */
    int i, key, fnd;    /* loop variable, number to find, location where found */
    char buf[BUFSIZ];
    int list[MAXENT];   /* an array for storing the location of those found */

    srand(time(NULL));  /* make actual random numbers */

    for (i=0; i < MAXENT; i++)
    { /* fill the table up with random numbers */
        tbl[i] = rand() % 100;  /* with numbers from 0 to 99 */
    }

    /*
     * The table is now filled
     * Loop through the table and display each entry
     */
    for (i=0; i < MAXENT; i++)
    { /* loop through the array */
        printf("Entry %2d is %2d\n", i, tbl[i]);
        if (i%20 == 19)
        { /* screen full - pause for user */
            printf("Press ENTER to continue: ");
            getchar(); /* wait for user to press ENTER */
        }
    }

    /*
     * now loop asking the user for a number, and find the first entry
     * containing that number
     */
    while (1)
    { /* loop until done */
        printf("Enter a number, or ENTER to quit: ");
        gets(buf);
        if (buf[0] == 0) break;
        key = atoi(buf);    /* the number we are looking for */
        fnd = list_matches(tbl, MAXENT, key, list);
        if (fnd == 0)
        {
            printf("Number %d not found in table\n", key);
        }
        else if (fnd == 1)
        { /* only found once - display simple message */
        	printf("Number %d found once at location: %d\n", key, list[0]);
        }
        else
        { /* found more than once - list all locations */
	        printf("Number %d first found %d times at locations: ", key, fnd);
        
        	/* now display the locations */
	        for (i=0; i < fnd; i++)
	        {
	            if (i > 0) printf(", ");
	            if (i == fnd-1) printf("and ");
	            printf("%d", list[i]);
	        }
	        printf("\n");
        }
    }

    printf("Press ENTER to terminate program: "); /* display another message */
	getchar(); 						/* wait for the user to press ENTER */
}

/* the list_matches routine */
int list_matches(int array[], int maxsize, int key, int list[])
{
    int i, fnd=0;  /* loop variable and how many matches */

    /*
     * Loop through array looking for a match with 'key'
     * Each time we find a match, save the location where found
     */
    for (i=0; i < maxsize; i++)
    {
     	if (array[i] != key) continue;  /* not a match, on to next entry */
        /* we found a match, keep track of where it was found */
        list[fnd] = i;  /* save location in next free slot in list */
        fnd++;
    }
    return fnd;  /* return how many matches we found */
}
