#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
 * This program gets information from the user and stores it
 * in a table
 */

#include "getinfo.h"

/* function prototypes */
int add_cust(struct cust cust[], int nent);
void display_cust(struct cust cust[], int nent);

main()
{
    char buf[BUFSIZ];
    struct cust Cust[MAXENT];
    int ncust=0;    /* number of customers */
    int i;          /* loop variable */
    int ret;        /* return value from add_cust */

    /* get information from the user and store it into an array */
    while (1)
    { /* loop getting information until done adding */
        if ((ret=add_cust(Cust, ncust)) == ADD_DONE) break;   /* done adding */
        if (ret != ADD_OK) continue;    /* bad add - ignore */
        /* entry looks ok - ask user to accept or reject record */
        display_cust(Cust, ncust);  /* display new customer */
        printf("Ok? (y or n): ");   /* ask if okay */
        gets(buf);
        if (buf[0] == 'n') continue;    /* not okay - try again */
        /* new entry accepted */
        ncust++;    /* one more customer in table */
    }

    /* all customers have been added, now display a list */
    for (i=0; i < ncust; i++)
    { /* loop through array of customers */
        printf("Entry %d: ", i);
        display_cust(Cust, i);
        if (i%20 == 19)
        { /* full screen - pause for user */
        	printf("Press ENTER to continue: ");
            getchar();
        }
    }

    printf("Press ENTER to terminate program: "); /* display another message */
	getchar(); 						/* wait for the user to press ENTER */
 }

/*
 * This function adds a customer to the table
 * If the user adds a customer, the function returns a zero
 * If the user is done, the function returns a non-zero value
 */
int add_cust(struct cust cust[], int ncust)
{
    char buf[BUFSIZ];

    printf("Enter customer ID or ENTER to quit: ");
    gets(buf);
    if (buf[0] == '\0') return ADD_DONE;   /* don't add */
    cust[ncust].id = atoi(buf);
    if (cust[ncust].id <= 0) return ADD_BAD;  /* invalid ID - reject entry */

    do
    { /* get last name */
		printf("Enter Last Name: ");
        gets(buf);
        /* if name isn't too long, copy it into structure */
        if (strlen(buf) < NAMESIZ) strcpy(cust[ncust].lname, buf);
    } while (strlen(buf) >= NAMESIZ);   /* keep looping until valid */

    do
    { /* get first name */
    	printf("Enter First Name: ");
    	gets(buf);
        if (strlen(buf) < NAMESIZ) strcpy(cust[ncust].fname, buf);
    } while (strlen(buf) >= NAMESIZ); /* keep looping until valid */

    /* now get balance */
    printf("Enter balance: ");
    gets(buf);
    cust[ncust].bal = atof(buf);    /* convert age to number */

    /* now increment how many customers we have */
    return ADD_OK;  /* valid add */
 }

void display_cust(struct cust cust[], int ent)
{
    printf("Customer %d: %s %s, bal %.2f\n", cust[ent].id, cust[ent].fname,
    		cust[ent].lname, cust[ent].bal);
}
